Bug 1967078 - condor fails to build in Fedora 35+: Broken RPATH will fail rpmbuild
Summary: condor fails to build in Fedora 35+: Broken RPATH will fail rpmbuild
Keywords:
Status: CLOSED DUPLICATE of bug 1977313
Alias: None
Product: Fedora
Classification: Fedora
Component: condor
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Tim Theisen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 1968788 (view as bug list)
Depends On:
Blocks: F35FTBFS F35FailsToInstall PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2021-06-02 12:08 UTC by Tomáš Hrnčiar
Modified: 2021-07-26 09:04 UTC (History)
11 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-07-26 09:04:41 UTC
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2021-06-02 12:08:50 UTC
condor fails to build with Python 3.10.0b2.

+ /usr/lib/rpm/check-rpaths
*******************************************************************************
*
* WARNING: 'check-rpaths' detected a broken RPATH OR RUNPATH and will cause
*          'rpmbuild' to fail. To ignore these errors, you can set the
*          '$QA_RPATHS' environment variable which is a bitmask allowing the
*          values below. The current value of QA_RPATHS is 0x0000.
*
*    0x0001 ... standard RPATHs (e.g. /usr/lib); such RPATHs are a minor
*               issue but are introducing redundant searchpaths without
*               providing a benefit. They can also cause errors in multilib
*               environments.
*    0x0002 ... invalid RPATHs; these are RPATHs which are neither absolute
*               nor relative filenames and can therefore be a SECURITY risk
*    0x0004 ... insecure RPATHs; these are relative RPATHs which are a
*               SECURITY risk
*    0x0008 ... the special '$ORIGIN' RPATHs are appearing after other
*               RPATHs; this is just a minor issue but usually unwanted
*    0x0010 ... the RPATH is empty; there is no reason for such RPATHs
*               and they cause unneeded work while loading libraries
*    0x0020 ... an RPATH references '..' of an absolute path; this will break
*               the functionality when the path before '..' is a symlink
*          
*
* Examples:
* - to ignore standard and empty RPATHs, execute 'rpmbuild' like
*   $ QA_RPATHS=$(( 0x0001|0x0010 )) rpmbuild my-package.src.rpm
* - to check existing files, set $RPM_BUILD_ROOT and execute check-rpaths like
*   $ RPM_BUILD_ROOT=<top-dir> /usr/lib/rpm/check-rpaths
*  
*******************************************************************************
ERROR   0001: file '/usr/share/condor/libcondorapi.so' contains a standard runpath '/lib64' in [$ORIGIN/../lib:/lib64:/usr/lib64:$ORIGIN/../lib/condor:/usr/lib64/condor]
ERROR   0001: file '/usr/share/condor/libcondorapi.so' contains a standard runpath '/usr/lib64' in [$ORIGIN/../lib:/lib64:/usr/lib64:$ORIGIN/../lib/condor:/usr/lib64/condor]
ERROR   0008: file '/usr/share/condor/libcondorapi.so' contains the $ORIGIN runpath specifier at the wrong position in [$ORIGIN/../lib:/lib64:/usr/lib64:$ORIGIN/../lib/condor:/usr/lib64/condor]
ERROR   0001: file '/usr/lib64/libpy3classad3.10_8_8_10.so' contains a standard runpath '/lib64' in [$ORIGIN/../lib:/lib64:/usr/lib64:$ORIGIN/../lib/condor:/usr/lib64/condor]
ERROR   0001: file '/usr/lib64/libpy3classad3.10_8_8_10.so' contains a standard runpath '/usr/lib64' in [$ORIGIN/../lib:/lib64:/usr/lib64:$ORIGIN/../lib/condor:/usr/lib64/condor]
ERROR   0008: file '/usr/lib64/libpy3classad3.10_8_8_10.so' contains the $ORIGIN runpath specifier at the wrong position in [$ORIGIN/../lib:/lib64:/usr/lib64:$ORIGIN/../lib/condor:/usr/lib64/condor]
ERROR   0001: file '/usr/lib64/libcondor_utils_8_8_10.so' contains a standard runpath '/lib64' in [$ORIGIN/../lib:/lib64:/usr/lib64:$ORIGIN/../lib/condor:/usr/lib64/condor]
ERROR   0001: file '/usr/lib64/libcondor_utils_8_8_10.so' contains a standard runpath '/usr/lib64' in [$ORIGIN/../lib:/lib64:/usr/lib64:$ORIGIN/../lib/condor:/usr/lib64/condor]
ERROR   0008: file '/usr/lib64/libcondor_utils_8_8_10.so' contains the $ORIGIN runpath specifier at the wrong position in [$ORIGIN/../lib:/lib64:/usr/lib64:$ORIGIN/../lib/condor:/usr/lib64/condor]
ERROR   0001: file '/usr/lib64/libclassad.so.8.8.10' contains a standard runpath '/lib64' in [$ORIGIN/../lib:/lib64:/usr/lib64:$ORIGIN/../lib/condor:/usr/lib64/condor]
ERROR   0001: file '/usr/lib64/libclassad.so.8.8.10' contains a standard runpath '/usr/lib64' in [$ORIGIN/../lib:/lib64:/usr/lib64:$ORIGIN/../lib/condor:/usr/lib64/condor]
ERROR   0008: file '/usr/lib64/libclassad.so.8.8.10' contains the $ORIGIN runpath specifier at the wrong position in [$ORIGIN/../lib:/lib64:/usr/lib64:$ORIGIN/../lib/condor:/usr/lib64/condor]
ERROR   0001: file '/usr/lib64/python3.10/site-packages/classad.so' contains a standard runpath '/lib64' in [$ORIGIN/../:/lib64:/usr/lib64:$ORIGIN/../condor]
ERROR   0001: file '/usr/lib64/python3.10/site-packages/classad.so' contains a standard runpath '/usr/lib64' in [$ORIGIN/../:/lib64:/usr/lib64:$ORIGIN/../condor]
ERROR   0008: file '/usr/lib64/python3.10/site-packages/classad.so' contains the $ORIGIN runpath specifier at the wrong position in [$ORIGIN/../:/lib64:/usr/lib64:$ORIGIN/../condor]
ERROR   0001: file '/usr/lib64/python3.10/site-packages/htcondor.so' contains a standard runpath '/lib64' in [$ORIGIN/../:/lib64:/usr/lib64:$ORIGIN/../condor]
ERROR   0001: file '/usr/lib64/python3.10/site-packages/htcondor.so' contains a standard runpath '/usr/lib64' in [$ORIGIN/../:/lib64:/usr/lib64:$ORIGIN/../condor]
ERROR   0008: file '/usr/lib64/python3.10/site-packages/htcondor.so' contains the $ORIGIN runpath specifier at the wrong position in [$ORIGIN/../:/lib64:/usr/lib64:$ORIGIN/../condor]
*******************************************************************************

https://fedoraproject.org/wiki/Changes/Broken_RPATH_will_fail_rpmbuild

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/02217382-condor/

For all our attempts to build condor with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/condor/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Miro Hrončok 2021-06-04 20:13:25 UTC
This is a mass-posted update. Sorry if it is not 100% accurate to this bugzilla.


The Python 3.10 rebuild is in progress in a Koji side tag. If you manage to fix the problem, please commit the fix in the rawhide branch, but don't build the package in regular rawhide.

You can either build the package in the side tag, with:

    $ fedpkg build --target=f35-python

Or you can the build and we will eventually build it for you.

Note that the rebuild is still in progress, so not all (build) dependencies of this package might be available right away.

Thanks.

See also https://fedoraproject.org/wiki/Changes/Python3.10

If you have general questions about the rebuild, please use this mailing list thread: https://lists.fedoraproject.org/archives/list/devel@lists.fedoraproject.org/thread/G47SGOYIQLRDTWGOSLSWERZSSHXDEDH5/

Comment 2 Tim Theisen 2021-06-04 20:26:10 UTC
I have a fix for the RPATH problem. However, HTCondor is not building for other reasons. I am currently working on bringing it up to version 9.1.0. However, the spec file needs work with this major upgrade. Once it builds in regular rawhide, I'll make sure that it works in f35-python as well.

Comment 3 Miro Hrončok 2021-06-07 22:58:14 UTC
The f35-python side tag has been merged to Rawhide. From now on, build as you would normally build.

Comment 4 Miro Hrončok 2021-06-08 11:14:05 UTC
*** Bug 1968788 has been marked as a duplicate of this bug. ***

Comment 5 Miro Hrončok 2021-07-26 09:04:41 UTC
The current problem is:

+ make -C docs man
make: Entering directory '/builddir/build/BUILD/htcondor-8_8_10/docs'
sphinx-build -b man -d _build/doctrees   . _build/man
Running Sphinx v4.0.2
WARNING: while setting up extension index: role 'index' is already registered, it will be overridden
making output directory... done
Exception occurred:
  File "/builddir/build/BUILD/htcondor-8_8_10/docs/conf.py", line 452, in setup
    app.add_stylesheet('css/htcondor-manual.css')
AttributeError: 'Sphinx' object has no attribute 'add_stylesheet'

*** This bug has been marked as a duplicate of bug 1977313 ***


Note You need to log in before you can comment on or make changes to this bug.